<html>
<head>
<title>Ogre::RTShader::SubRenderState Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="namespaceOgre_1_1RTShader.html">RTShader</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::RTShader::SubRenderState Class Reference<div class="ingroups"><a class="el" href="group__RTShader.html">RTShader</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::RTShader::SubRenderState" --><!-- doxytag: inherits="Ogre::AllocatedObject" -->
<p>This class is the base interface of sub part from a shader based rendering pipeline.  
 <a href="classOgre_1_1RTShader_1_1SubRenderState.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreShaderSubRenderState_8h_source.html">OgreShaderSubRenderState.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::RTShader::SubRenderState:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1RTShader_1_1SubRenderState__inherit__graph.gif" border="0" usemap="#Ogre_1_1RTShader_1_1SubRenderState_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1RTShader_1_1SubRenderState_inherit__map" id="Ogre_1_1RTShader_1_1SubRenderState_inherit__map">
<area shape="rect" id="node2" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator..." alt="" coords="39,5,193,35"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1RTShader_1_1SubRenderState-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#a5d88199139341a68af49c05b76851cd5">SubRenderState</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Class default constructor.  <a href="#a5d88199139341a68af49c05b76851cd5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#ae6584380f14f72ad3a94323e6f37a067">~SubRenderState</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Class destructor.  <a href="#ae6584380f14f72ad3a94323e6f37a067"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#ae91b7b8f76848d67652b6e5832a27a49">getType</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the type of this sub render state.  <a href="#ae91b7b8f76848d67652b6e5832a27a49"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#acb48c34ee231f0220f68c967fb32f1e5">getExecutionOrder</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the execution order of this sub render state.  <a href="#acb48c34ee231f0220f68c967fb32f1e5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#a5dfe9f03413e0fe99ea2640f06c1f13c">copyFrom</a> (const <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> &amp;rhs)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Copy details from a given sub render state to this one.  <a href="#a5dfe9f03413e0fe99ea2640f06c1f13c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#a78bda908965b63ceceb6f66fc480a53b">operator=</a> (const <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> &amp;rhs)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Operator = declaration.  <a href="#a78bda908965b63ceceb6f66fc480a53b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#a4b43c261946926ebbc6456deccc6697a">createCpuSubPrograms</a> (<a class="el" href="classOgre_1_1RTShader_1_1ProgramSet.html">ProgramSet</a> *programSet)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create sub programs that represents this sub render state as part of a program set.  <a href="#a4b43c261946926ebbc6456deccc6697a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#a4c2acbc15e44c3fe42868abce1116ec2">updateGpuProgramsParams</a> (<a class="el" href="classOgre_1_1Renderable.html">Renderable</a> *rend, <a class="el" href="classOgre_1_1Pass.html">Pass</a> *pass, const <a class="el" href="classOgre_1_1AutoParamDataSource.html">AutoParamDataSource</a> *source, const <a class="el" href="group__General.html#gaab30ef14aae93306a6044cb38d835f0c">LightList</a> *pLightList)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Update GPU programs parameters before a rendering operation occurs.  <a href="#a4c2acbc15e44c3fe42868abce1116ec2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#afd08043cfad43a1ae470c3c1be341ba1">preAddToRenderState</a> (const <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html">RenderState</a> *renderState, <a class="el" href="classOgre_1_1Pass.html">Pass</a> *srcPass, <a class="el" href="classOgre_1_1Pass.html">Pass</a> *dstPass)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Called before adding this sub render state to the given render state.  <a href="#afd08043cfad43a1ae470c3c1be341ba1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__RTShader.html#gaecbe3817ee5b43f1962309c03d39da99">SubRenderStateAccessorPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#aa73560a3f1b9117cb8b438867848c255">getAccessor</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the accessor object to this sub render state.  <a href="#aa73560a3f1b9117cb8b438867848c255"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__RTShader.html#gaecbe3817ee5b43f1962309c03d39da99">SubRenderStateAccessorPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#a4023f69bcd64cf1f4f2e68d23cd627c3">getAccessor</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the accessor object to this sub render state.  <a href="#a4023f69bcd64cf1f4f2e68d23cd627c3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a421b197ca3a38da17e2eb1531a645fa2">operator new</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">operator new, with debug line info  <a href="#a421b197ca3a38da17e2eb1531a645fa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ac4bdf968b7b9af8a5239a27da73d5711">operator new</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ab78a921e54419be677839cdf15d1f0b8">operator new</a> (size_t sz, void *ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">placement operator new  <a href="#ab78a921e54419be677839cdf15d1f0b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a4be37baef81876985aa1071ad5acc6dd">operator new[]</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">array operator new, with debug line info  <a href="#a4be37baef81876985aa1071ad5acc6dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#afa2943846ba6a2b5824a12857139cf5e">operator new[]</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a8357fe4fb4849772b94baa4bf47c7ded">operator delete</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a1c727e879a260c37b00ce5505fe8e144">operator delete</a> (void *ptr, void *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#acb46d4b0a597156d9ba5abc39d127792">operator delete</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a93e6a86dde5483c053ca0f2a85bbfd6c">operator delete[]</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a595ea4c05da8aa987d3800e65d23355d">operator delete[]</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td colspan="2"><h2><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#abb9932fdd1eb78cb640b652e8def029e">resolveParameters</a> (<a class="el" href="classOgre_1_1RTShader_1_1ProgramSet.html">ProgramSet</a> *programSet)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Resolve parameters that this sub render state requires.  <a href="#abb9932fdd1eb78cb640b652e8def029e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#a124daf32baf4d90d6854bec1bb4eced1">resolveDependencies</a> (<a class="el" href="classOgre_1_1RTShader_1_1ProgramSet.html">ProgramSet</a> *programSet)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Resolve dependencies that this sub render state requires.  <a href="#a124daf32baf4d90d6854bec1bb4eced1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#a6759aa937ba07f3f6c12e4c48a8b72c2">addFunctionInvocations</a> (<a class="el" href="classOgre_1_1RTShader_1_1ProgramSet.html">ProgramSet</a> *programSet)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Add function invocation that this sub render state requires.  <a href="#a6759aa937ba07f3f6c12e4c48a8b72c2"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__RTShader.html#gaecbe3817ee5b43f1962309c03d39da99">SubRenderStateAccessorPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#afa120902df67e9b38dbff17e1df64b59">mThisAccessor</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__RTShader.html#gaecbe3817ee5b43f1962309c03d39da99">SubRenderStateAccessorPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#a0b6e254c421c86807085ae4eb60403b2">mOtherAccessor</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This class is the base interface of sub part from a shader based rendering pipeline. </p>
<p>All sub parts implementations should derive from it and implement the needed methods. A simple example of sub class of this interface will be the transform sub state of the fixed pipeline. </p>

<p>Definition at line <a class="el" href="OgreShaderSubRenderState_8h_source.html#l00056">56</a> of file <a class="el" href="OgreShaderSubRenderState_8h_source.html">OgreShaderSubRenderState.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a5d88199139341a68af49c05b76851cd5"></a><!-- doxytag: member="Ogre::RTShader::SubRenderState::SubRenderState" ref="a5d88199139341a68af49c05b76851cd5" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#a5d88199139341a68af49c05b76851cd5">Ogre::RTShader::SubRenderState::SubRenderState</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Class default constructor. </p>

</div>
</div>
<a class="anchor" id="ae6584380f14f72ad3a94323e6f37a067"></a><!-- doxytag: member="Ogre::RTShader::SubRenderState::~SubRenderState" ref="ae6584380f14f72ad3a94323e6f37a067" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#ae6584380f14f72ad3a94323e6f37a067">Ogre::RTShader::SubRenderState::~SubRenderState</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Class destructor. </p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a6759aa937ba07f3f6c12e4c48a8b72c2"></a><!-- doxytag: member="Ogre::RTShader::SubRenderState::addFunctionInvocations" ref="a6759aa937ba07f3f6c12e4c48a8b72c2" args="(ProgramSet *programSet)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#a6759aa937ba07f3f6c12e4c48a8b72c2">Ogre::RTShader::SubRenderState::addFunctionInvocations</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1ProgramSet.html">ProgramSet</a> *&#160;</td>
          <td class="paramname"><em>programSet</em></td><td>)</td>
          <td><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Add function invocation that this sub render state requires. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">programSet</td><td>container class of CPU and GPU programs that this sub state will affect on. </td></tr>
  </table>
  </dd>
</dl>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Internal method called in the context of <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#a4b43c261946926ebbc6456deccc6697a" title="Create sub programs that represents this sub render state as part of a program set.">SubRenderState::createCpuSubPrograms</a> implementation. </dd></dl>

</div>
</div>
<a class="anchor" id="a5dfe9f03413e0fe99ea2640f06c1f13c"></a><!-- doxytag: member="Ogre::RTShader::SubRenderState::copyFrom" ref="a5dfe9f03413e0fe99ea2640f06c1f13c" args="(const SubRenderState &amp;rhs)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#a5dfe9f03413e0fe99ea2640f06c1f13c">Ogre::RTShader::SubRenderState::copyFrom</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> &amp;&#160;</td>
          <td class="paramname"><em>rhs</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Copy details from a given sub render state to this one. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">rhs</td><td>the source sub state to copy from. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a4b43c261946926ebbc6456deccc6697a"></a><!-- doxytag: member="Ogre::RTShader::SubRenderState::createCpuSubPrograms" ref="a4b43c261946926ebbc6456deccc6697a" args="(ProgramSet *programSet)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#a4b43c261946926ebbc6456deccc6697a">Ogre::RTShader::SubRenderState::createCpuSubPrograms</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1ProgramSet.html">ProgramSet</a> *&#160;</td>
          <td class="paramname"><em>programSet</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create sub programs that represents this sub render state as part of a program set. </p>
<p>The given program set contains CPU programs that represents a vertex shader and pixel shader. One should use these program class API to create a representation of the sub state he wished to implement. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">programSet</td><td>container class of CPU and GPU programs that this sub state will affect on. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aa73560a3f1b9117cb8b438867848c255"></a><!-- doxytag: member="Ogre::RTShader::SubRenderState::getAccessor" ref="aa73560a3f1b9117cb8b438867848c255" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__RTShader.html#gaecbe3817ee5b43f1962309c03d39da99">SubRenderStateAccessorPtr</a> <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#aa73560a3f1b9117cb8b438867848c255">Ogre::RTShader::SubRenderState::getAccessor</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the accessor object to this sub render state. </p>
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html" title="This class uses as accessor from a template SubRenderState to all of its instances that created based...">SubRenderStateAccessor</a>. </dd></dl>

</div>
</div>
<a class="anchor" id="a4023f69bcd64cf1f4f2e68d23cd627c3"></a><!-- doxytag: member="Ogre::RTShader::SubRenderState::getAccessor" ref="a4023f69bcd64cf1f4f2e68d23cd627c3" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__RTShader.html#gaecbe3817ee5b43f1962309c03d39da99">SubRenderStateAccessorPtr</a> <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#aa73560a3f1b9117cb8b438867848c255">Ogre::RTShader::SubRenderState::getAccessor</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the accessor object to this sub render state. </p>
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1RTShader_1_1SubRenderStateAccessor.html" title="This class uses as accessor from a template SubRenderState to all of its instances that created based...">SubRenderStateAccessor</a>. </dd></dl>

</div>
</div>
<a class="anchor" id="acb48c34ee231f0220f68c967fb32f1e5"></a><!-- doxytag: member="Ogre::RTShader::SubRenderState::getExecutionOrder" ref="acb48c34ee231f0220f68c967fb32f1e5" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual int <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#acb48c34ee231f0220f68c967fb32f1e5">Ogre::RTShader::SubRenderState::getExecutionOrder</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the execution order of this sub render state. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>The return value should be synchronized with the predefined values of the FFPShaderStage enum. </dd></dl>

</div>
</div>
<a class="anchor" id="ae91b7b8f76848d67652b6e5832a27a49"></a><!-- doxytag: member="Ogre::RTShader::SubRenderState::getType" ref="ae91b7b8f76848d67652b6e5832a27a49" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#ae91b7b8f76848d67652b6e5832a27a49">Ogre::RTShader::SubRenderState::getType</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the type of this sub render state. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>The type string should be unique among all registered sub render states. </dd></dl>

</div>
</div>
<a class="anchor" id="a8357fe4fb4849772b94baa4bf47c7ded"></a><!-- doxytag: member="Ogre::RTShader::SubRenderState::operator delete" ref="a8357fe4fb4849772b94baa4bf47c7ded" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00095">95</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1c727e879a260c37b00ce5505fe8e144"></a><!-- doxytag: member="Ogre::RTShader::SubRenderState::operator delete" ref="a1c727e879a260c37b00ce5505fe8e144" args="(void *ptr, void *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00101">101</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="acb46d4b0a597156d9ba5abc39d127792"></a><!-- doxytag: member="Ogre::RTShader::SubRenderState::operator delete" ref="acb46d4b0a597156d9ba5abc39d127792" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00107">107</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a93e6a86dde5483c053ca0f2a85bbfd6c"></a><!-- doxytag: member="Ogre::RTShader::SubRenderState::operator delete[]" ref="a93e6a86dde5483c053ca0f2a85bbfd6c" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00112">112</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a595ea4c05da8aa987d3800e65d23355d"></a><!-- doxytag: member="Ogre::RTShader::SubRenderState::operator delete[]" ref="a595ea4c05da8aa987d3800e65d23355d" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00118">118</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a421b197ca3a38da17e2eb1531a645fa2"></a><!-- doxytag: member="Ogre::RTShader::SubRenderState::operator new" ref="a421b197ca3a38da17e2eb1531a645fa2" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00067">67</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac4bdf968b7b9af8a5239a27da73d5711"></a><!-- doxytag: member="Ogre::RTShader::SubRenderState::operator new" ref="ac4bdf968b7b9af8a5239a27da73d5711" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00072">72</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab78a921e54419be677839cdf15d1f0b8"></a><!-- doxytag: member="Ogre::RTShader::SubRenderState::operator new" ref="ab78a921e54419be677839cdf15d1f0b8" args="(size_t sz, void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>placement operator new </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00078">78</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4be37baef81876985aa1071ad5acc6dd"></a><!-- doxytag: member="Ogre::RTShader::SubRenderState::operator new[]" ref="a4be37baef81876985aa1071ad5acc6dd" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>array operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00085">85</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa2943846ba6a2b5824a12857139cf5e"></a><!-- doxytag: member="Ogre::RTShader::SubRenderState::operator new[]" ref="afa2943846ba6a2b5824a12857139cf5e" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00090">90</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a78bda908965b63ceceb6f66fc480a53b"></a><!-- doxytag: member="Ogre::RTShader::SubRenderState::operator=" ref="a78bda908965b63ceceb6f66fc480a53b" args="(const SubRenderState &amp;rhs)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a>&amp; Ogre::RTShader::SubRenderState::operator= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> &amp;&#160;</td>
          <td class="paramname"><em>rhs</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Operator = declaration. </p>
<p>Assign the given source sub state to this sub state. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">rhs</td><td>the source sub state to copy from. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="afd08043cfad43a1ae470c3c1be341ba1"></a><!-- doxytag: member="Ogre::RTShader::SubRenderState::preAddToRenderState" ref="afd08043cfad43a1ae470c3c1be341ba1" args="(const RenderState *renderState, Pass *srcPass, Pass *dstPass)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#afd08043cfad43a1ae470c3c1be341ba1">Ogre::RTShader::SubRenderState::preAddToRenderState</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html">RenderState</a> *&#160;</td>
          <td class="paramname"><em>renderState</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Pass.html">Pass</a> *&#160;</td>
          <td class="paramname"><em>srcPass</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Pass.html">Pass</a> *&#160;</td>
          <td class="paramname"><em>dstPass</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Called before adding this sub render state to the given render state. </p>
<p>Allows this sub render state class to configure specific parameters depending on source pass or parent render state. Return of false value will cause canceling the add operation. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">renderState</td><td>The target render state container this sub render state is about to be added. </td></tr>
    <tr><td class="paramname">srcPass</td><td>The source pass. </td></tr>
    <tr><td class="paramname">dstPass</td><td>The destination pass. </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="OgreShaderSubRenderState_8h_source.html#l00120">120</a> of file <a class="el" href="OgreShaderSubRenderState_8h_source.html">OgreShaderSubRenderState.h</a>.</p>

</div>
</div>
<a class="anchor" id="a124daf32baf4d90d6854bec1bb4eced1"></a><!-- doxytag: member="Ogre::RTShader::SubRenderState::resolveDependencies" ref="a124daf32baf4d90d6854bec1bb4eced1" args="(ProgramSet *programSet)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#a124daf32baf4d90d6854bec1bb4eced1">Ogre::RTShader::SubRenderState::resolveDependencies</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1ProgramSet.html">ProgramSet</a> *&#160;</td>
          <td class="paramname"><em>programSet</em></td><td>)</td>
          <td><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Resolve dependencies that this sub render state requires. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">programSet</td><td>container class of CPU and GPU programs that this sub state will affect on. </td></tr>
  </table>
  </dd>
</dl>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Internal method called in the context of <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#a4b43c261946926ebbc6456deccc6697a" title="Create sub programs that represents this sub render state as part of a program set.">SubRenderState::createCpuSubPrograms</a> implementation. </dd></dl>

</div>
</div>
<a class="anchor" id="abb9932fdd1eb78cb640b652e8def029e"></a><!-- doxytag: member="Ogre::RTShader::SubRenderState::resolveParameters" ref="abb9932fdd1eb78cb640b652e8def029e" args="(ProgramSet *programSet)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#abb9932fdd1eb78cb640b652e8def029e">Ogre::RTShader::SubRenderState::resolveParameters</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1ProgramSet.html">ProgramSet</a> *&#160;</td>
          <td class="paramname"><em>programSet</em></td><td>)</td>
          <td><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Resolve parameters that this sub render state requires. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">programSet</td><td>container class of CPU and GPU programs that this sub state will affect on. </td></tr>
  </table>
  </dd>
</dl>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Internal method called in the context of <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#a4b43c261946926ebbc6456deccc6697a" title="Create sub programs that represents this sub render state as part of a program set.">SubRenderState::createCpuSubPrograms</a> implementation. </dd></dl>

</div>
</div>
<a class="anchor" id="a4c2acbc15e44c3fe42868abce1116ec2"></a><!-- doxytag: member="Ogre::RTShader::SubRenderState::updateGpuProgramsParams" ref="a4c2acbc15e44c3fe42868abce1116ec2" args="(Renderable *rend, Pass *pass, const AutoParamDataSource *source, const LightList *pLightList)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#a4c2acbc15e44c3fe42868abce1116ec2">Ogre::RTShader::SubRenderState::updateGpuProgramsParams</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Renderable.html">Renderable</a> *&#160;</td>
          <td class="paramname"><em>rend</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Pass.html">Pass</a> *&#160;</td>
          <td class="paramname"><em>pass</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1AutoParamDataSource.html">AutoParamDataSource</a> *&#160;</td>
          <td class="paramname"><em>source</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="group__General.html#gaab30ef14aae93306a6044cb38d835f0c">LightList</a> *&#160;</td>
          <td class="paramname"><em>pLightList</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Update GPU programs parameters before a rendering operation occurs. </p>
<p>This method is called in the context of SceneManager::renderSingle object via the <a class="el" href="classOgre_1_1RenderObjectListener.html" title="Abstract interface which classes must implement if they wish to receive events from the scene manager...">RenderObjectListener</a> interface and lets this sub render state instance opportunity to update custom GPU program parameters before the rendering action occurs. </p>
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1RenderObjectListener.html#a99b1b17e89efbbce74756925a4acad38" title="Event raised when render single object started.">RenderObjectListener::notifyRenderSingleObject</a>. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">rend</td><td>The renderable that is about to be rendered. </td></tr>
    <tr><td class="paramname">pass</td><td>The pass that used for this rendering.  The auto parameter source.  The light list used in the current rendering context. </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="OgreShaderSubRenderState_8h_source.html#l00111">111</a> of file <a class="el" href="OgreShaderSubRenderState_8h_source.html">OgreShaderSubRenderState.h</a>.</p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a0b6e254c421c86807085ae4eb60403b2"></a><!-- doxytag: member="Ogre::RTShader::SubRenderState::mOtherAccessor" ref="a0b6e254c421c86807085ae4eb60403b2" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__RTShader.html#gaecbe3817ee5b43f1962309c03d39da99">SubRenderStateAccessorPtr</a> <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#a0b6e254c421c86807085ae4eb60403b2">Ogre::RTShader::SubRenderState::mOtherAccessor</a><code> [private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderSubRenderState_8h_source.html#l00156">156</a> of file <a class="el" href="OgreShaderSubRenderState_8h_source.html">OgreShaderSubRenderState.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa120902df67e9b38dbff17e1df64b59"></a><!-- doxytag: member="Ogre::RTShader::SubRenderState::mThisAccessor" ref="afa120902df67e9b38dbff17e1df64b59" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__RTShader.html#gaecbe3817ee5b43f1962309c03d39da99">SubRenderStateAccessorPtr</a> <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html#afa120902df67e9b38dbff17e1df64b59">Ogre::RTShader::SubRenderState::mThisAccessor</a><code> [mutable, private]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderSubRenderState_8h_source.html#l00155">155</a> of file <a class="el" href="OgreShaderSubRenderState_8h_source.html">OgreShaderSubRenderState.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreShaderSubRenderState_8h_source.html">OgreShaderSubRenderState.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:33
</p>
</body>
</html>
